Gives increased control over Valheim's networking and **automatically improves performance.**

**For most people, the default settings will greatly decrease desync and lag between players who have the mod.**

If you're looking for further improvements, you can change the settings of Better Networking in the Configuration Manager (F1). Settings are applied in real time (except for dedicated servers, which need to be restarted (for now)). Try the following:

* **If Person A is experiencing desync/lag while Person B is around, but Person B's character seems fine, Person B needs to increase their queue size.**
* **If Person A is experiencing desync/lag while Person B is around, *including for Person B's character*, Person B needs to decrease their update rate and/or queue size.**
* **﻿Try adjusting both send rates to be the highest option available below your internet upload speed.** (These options are likely less important than the other ones.)
* **Simply installing the mod for everyone, including the dedicated server (if you're using one), can increase multiplayer performance by 2x-3x, often more.** I'm not kidding. I'm so pleased with the results of this.

Three things to note:

1. Incompatible with other networking mods, including VNO, NetworkFix, and *sometimes* Serverside Simulations, to name a few.
1. Compression increases your CPU usage. This can become the new bottleneck in some cases. With this mod, Valheim can max out two cores, so with 4 cores, 50% CPU usage by Valheim is maxing it out.
1. If you're currently experiencing 10 seconds of lag, reducing it to 3 seconds is still a lot of lag.

Better Networking gives you the power to make your multiplayer experience better *or* worse. Use the power responsibly, experiment, and let others (including me) know what works and what doesn't [here in the discussions](https://www.nexusmods.com/valheim/mods/1570?tab=posts). For a detailed breakdown of Valheim networking, check out [this reddit post](https://redd.it/mga1iw) by u/SleepMyLittleOnes.

**Finished features**

* compress network data (improves performance for everyone; requires others to have mod)
* sending queued packages all at once instead of one at a time (improves performance for everyone, especially if you have high ping; requires others to have mod)
* option to reduce network update speed (for computers with slow/inconsistent upload speeds)
* change min/max send rates (higher can be better with good internet)
* change network queue size (Valheim better prioritizes data when queue size is lower, but sends less data overall)
* [size=2][/size]increased networking buffer size (might help)

**Planned features**
* option to turn compression off (useful if your bottleneck is the CPU or you want to compare performance)
* skip compression if you're on the same computer as the dedicated server (although maybe that's covered by the above)
* reduce CPU usage
* don't compress small messages
* allow admins to change dedicated server settings within their client without having to restart server
* option to allow players to choose who the server is
* better data prioritization
* improved networking regarding terrain
* automatic queue size
* make everything automatic so that no advanced options or instructions are necessary

**If you've benefited from this mod and want to see more features implemented, please endorse it! Or if you're feeling particularly generous, donate here or **[on Patreon](https://www.patreon.com/CW_Jesse)**!**